<ng-container *ngIf="(users$ | async) as users; else loading">

  <ng-container *ngIf="users.length > 0; else noUsers">
    <table>
      <thead>
        <tr>
          <th>#</th>
          <th>ID</th>
          <th>Name</th>
          <th>Age</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let u of users; let row=index">
          <td>{{row + 1}}</td>
          <td>{{u.id}}</td>
          <td>{{u.name | titlecase}}</td>
          <td>{{u.age}}</td>
          <td>
            <a [routerLink]="['/users/show', u.id]">SHOW</a>
          </td>
        </tr>
      </tbody>
    </table>

    <router-outlet></router-outlet>
  </ng-container>

  <ng-template #noUsers>
    <div>
      Sorry, no users defined!
    </div>
  </ng-template>
</ng-container>

<ng-template #loading>
  <div>
    Loading users...
  </div>
</ng-template>
